/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#include <nepomuk2/variant.h>
#include <nepomuk2/resourcemanager.h>
#include "bookmarkfolder.h"

#include "bookmark.h"
#include "bookmarkfolder.h"

#include <QtCore/QDateTime>
#include <QtCore/QDate>
#include <QtCore/QTime>


Nepomuk2::BookmarkFolder::BookmarkFolder()
  : Resource( QUrl(), QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#BookmarkFolder") )
{
}



Nepomuk2::BookmarkFolder::BookmarkFolder( const BookmarkFolder& res )
  : Resource( res )
{
}


Nepomuk2::BookmarkFolder::BookmarkFolder( const Nepomuk2::Resource& res )
  : Resource( res )
{
}


Nepomuk2::BookmarkFolder::BookmarkFolder( const QString& uri )
  : Resource( uri, QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#BookmarkFolder") )
{
}

Nepomuk2::BookmarkFolder::BookmarkFolder( const QUrl& uri )
  : Resource( uri, QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#BookmarkFolder") )
{
}

Nepomuk2::BookmarkFolder::BookmarkFolder( const QString& uri, const QUrl& type )
  : Resource( uri, type )
{
}


Nepomuk2::BookmarkFolder::BookmarkFolder( const QUrl& uri, const QUrl& type )
  : Resource( uri, type )
{
}

Nepomuk2::BookmarkFolder::~BookmarkFolder()
{
}

Nepomuk2::BookmarkFolder& Nepomuk2::BookmarkFolder::operator=( const BookmarkFolder& res )
{
    Resource::operator=( res );
    return *this;
}

QString Nepomuk2::BookmarkFolder::resourceTypeUri()
{
    return QLatin1String("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#BookmarkFolder");
}

QList<Nepomuk2::BookmarkFolder> Nepomuk2::BookmarkFolder::containsBookmarkFolders() const
{
    // We always store all Resource types as plain Resource objects.
    // It does not introduce any overhead (due to the implicit sharing of
    // the data and has the advantage that we can mix setProperty calls
    // with the special Resource subclass methods.
    // More importantly Resource loads the data as Resource objects anyway.
    QList<BookmarkFolder> rl;
    QList<Resource> l = property( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#containsBookmarkFolder") ).toResourceList() ;
    for( QList<Resource>::const_iterator it = l.constBegin();
        it != l.constEnd(); ++it )
    rl.append( BookmarkFolder( *it ) );
    return rl;
}

void Nepomuk2::BookmarkFolder::setContainsBookmarkFolders( const QList<Nepomuk2::BookmarkFolder>& value )
{
    // We always store all Resource types as plain Resource objects.
    // It does not introduce any overhead (due to the implicit sharing of
    // the data and has the advantage that we can mix setProperty calls
    // with the special Resource subclass methods.
    // More importantly Resource loads the data as Resource objects anyway.
    QList<Resource> l;
    for( QList<BookmarkFolder>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
        l.append( Resource( (*it) ) );
    }
    setProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#containsBookmarkFolder"), Variant( l ) );
}

void Nepomuk2::BookmarkFolder::addContainsBookmarkFolder( const Nepomuk2::BookmarkFolder& value )
{
    // We always store all Resource types as plain Resource objects.
    // It does not introduce any overhead (due to the implicit sharing of
    // the data and has the advantage that we can mix setProperty calls
    // with the special Resource subclass methods.
    // More importantly Resource loads the data as Resource objects anyway.
    Variant v = property( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#containsBookmarkFolder") );
    v.append( Resource( value ) );
    setProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#containsBookmarkFolder"), v );
}

QUrl Nepomuk2::BookmarkFolder::containsBookmarkFolderUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#containsBookmarkFolder");
}

QList<Nepomuk2::Bookmark> Nepomuk2::BookmarkFolder::containsBookmarks() const
{
    // We always store all Resource types as plain Resource objects.
    // It does not introduce any overhead (due to the implicit sharing of
    // the data and has the advantage that we can mix setProperty calls
    // with the special Resource subclass methods.
    // More importantly Resource loads the data as Resource objects anyway.
    QList<Bookmark> rl;
    QList<Resource> l = property( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#containsBookmark") ).toResourceList() ;
    for( QList<Resource>::const_iterator it = l.constBegin();
        it != l.constEnd(); ++it )
    rl.append( Bookmark( *it ) );
    return rl;
}

void Nepomuk2::BookmarkFolder::setContainsBookmarks( const QList<Nepomuk2::Bookmark>& value )
{
    // We always store all Resource types as plain Resource objects.
    // It does not introduce any overhead (due to the implicit sharing of
    // the data and has the advantage that we can mix setProperty calls
    // with the special Resource subclass methods.
    // More importantly Resource loads the data as Resource objects anyway.
    QList<Resource> l;
    for( QList<Bookmark>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
        l.append( Resource( (*it) ) );
    }
    setProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#containsBookmark"), Variant( l ) );
}

void Nepomuk2::BookmarkFolder::addContainsBookmark( const Nepomuk2::Bookmark& value )
{
    // We always store all Resource types as plain Resource objects.
    // It does not introduce any overhead (due to the implicit sharing of
    // the data and has the advantage that we can mix setProperty calls
    // with the special Resource subclass methods.
    // More importantly Resource loads the data as Resource objects anyway.
    Variant v = property( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#containsBookmark") );
    v.append( Resource( value ) );
    setProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#containsBookmark"), v );
}

QUrl Nepomuk2::BookmarkFolder::containsBookmarkUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#containsBookmark");
}


